<?php

namespace Opencart\Admin\Model\Extension\Xamax\Payment;

use Opencart\System\Engine\Model;

class Xamax extends Model {
  public function install() {
    $this->db->query("
      CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "xamax_order` (
        `xamax_order_id` INT(11) NOT NULL AUTO_INCREMENT,
        `order_id` INT(11) NOT NULL,
        `xamax_id` VARCHAR(100) NOT NULL,
        `xamax_code` VARCHAR(100) NOT NULL,
        `xamax_wallet` VARCHAR(100) NOT NULL,
        `xamax_amount` VARCHAR(100) NOT NULL,
        `xamax_amount_unit` VARCHAR(100) NOT NULL,
        `xamax_status` VARCHAR(100) NOT NULL,
        `created_at` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
        PRIMARY KEY (`xamax_order_id`)
      ) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;
    ");

    $this->load->model('setting/setting');

    $defaults = array();

    $defaults['payment_xamax_test_mode'] = 1;
    $defaults['payment_xamax_order_status_id'] = 1;
    $defaults['payment_xamax_pending_status_id'] = 1;
    $defaults['payment_xamax_confirming_status_id'] = 1;
    $defaults['payment_xamax_processing_status_id'] = 2;
    $defaults['payment_xamax_invalid_status_id'] = 10;
    $defaults['payment_xamax_expired_status_id'] = 14;
    $defaults['payment_xamax_canceled_status_id'] = 7;
    $defaults['payment_xamax_refunded_status_id'] = 11;
    $defaults['payment_xamax_sort_order'] = 0;

    $this->model_setting_setting->editSetting('payment_xamax', $defaults);
  }

  public function uninstall() {
    $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "xamax_order`;");
  }
}
