<?php
namespace Opencart\Catalog\Model\Extension\Xamax\Payment;

use Opencart\System\Engine\Model;

class Xamax extends Model {
	public function getMethods(array $address = []) {
		$this->load->language('extension/xamax/payment/xamax');

		if ($this->cart->hasSubscription()) {
			$status = false;
		} elseif (!$this->config->get('payment_xamax_geo_zone_id')) {
			$status = true;
		} else {
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('payment_xamax_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");
			// if the rows found the status set to True
			if ($query->num_rows) {
				$status = true;
			} else {
				$status = false;
			}
		}

		$method_data = array();

		if ($status) {
			$option_data['xamax'] = [
				'code' => 'xamax.xamax',
				'name' => $this->language->get('method_title')
			];

			$method_data = array(
				'code'       => 'xamax',
				'name'       => $this->language->get('heading_title'),
				'option'     => $option_data,
				'sort_order' => $this->config->get('sort_order')
			);
		}

		return $method_data;
	}
  public function addOrder($data) {
    $this->db->query("INSERT INTO `" . DB_PREFIX . "xamax_order` SET `order_id` = '" . (int)$data['order_id'] . "', `xamax_id` = '" . $this->db->escape($data['xamax_id']) . "', `xamax_code` = '" . $this->db->escape($data['xamax_code']) . "', `xamax_wallet` = '" . $this->db->escape($data['xamax_wallet']) . "', `xamax_amount` = '" . $this->db->escape($data['xamax_amount']) . "', `xamax_amount_unit` = '" . $this->db->escape($data['xamax_amount_unit']) . "', `xamax_status` = '" . $this->db->escape($data['xamax_status']) . "'");
  }

  public function getOrder($order_id) {
    $query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "xamax_order` WHERE `order_id` = '" . (int)$order_id . "' LIMIT 1");

    return $query->row;
  }

  public function getMethod($address, $total) {
    $this->load->language('extension/xamax/payment/xamax');

    $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('payment_xamax_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

    if ($this->config->get('payment_xamax_total') > 0 && $this->config->get('payment_xamax_total') > $total) {
      $status = false;
    } elseif (!$this->config->get('payment_xamax_geo_zone_id')) {
      $status = true;
    } elseif ($query->num_rows) {
      $status = true;
    } else {
      $status = false;
    }

    $method_data = array();

    if ($status) {
      $method_data = array(
        'code'		 => 'xamax',
        'title'		 => $this->language->get('text_title'),
        'terms'		 => '',
        'sort_order' => $this->config->get('payment_xamax_sort_order')
      );
    }

    return $method_data;
  }
}
